(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', './kotlin-kotlin-stdlib.js'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('./kotlin-kotlin-stdlib.js'));
  else {
    if (typeof this['kotlin-kotlin-stdlib'] === 'undefined') {
      throw new Error("Error loading module 'kotlin-codepoints-parent-kotlin-codepoints'. Its dependency 'kotlin-kotlin-stdlib' was not found. Please, check whether 'kotlin-kotlin-stdlib' is loaded prior to 'kotlin-codepoints-parent-kotlin-codepoints'.");
    }
    root['kotlin-codepoints-parent-kotlin-codepoints'] = factory(typeof this['kotlin-codepoints-parent-kotlin-codepoints'] === 'undefined' ? {} : this['kotlin-codepoints-parent-kotlin-codepoints'], this['kotlin-kotlin-stdlib']);
  }
}(globalThis, function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var protoOf = kotlin_kotlin.$_$.v;
  var numberToChar = kotlin_kotlin.$_$.t;
  var initMetadataForObject = kotlin_kotlin.$_$.r;
  var Unit_instance = kotlin_kotlin.$_$.i;
  //endregion
  //region block: pre-declaration
  initMetadataForObject(CodePoints, 'CodePoints');
  //endregion
  function CodePoints() {
    this.r3_1 = 65536;
    this.s3_1 = 1114111;
    this.t3_1 = 55296;
    this.u3_1 = 56320;
    this.v3_1 = -56613888;
    this.w3_1 = 55232;
  }
  protoOf(CodePoints).x3 = function (codePoint) {
    return (codePoint >>> 16 | 0) === 0;
  };
  protoOf(CodePoints).y3 = function (codePoint) {
    return numberToChar((codePoint >>> 10 | 0) + 55232 | 0);
  };
  protoOf(CodePoints).z3 = function (codePoint) {
    return numberToChar((codePoint & 1023) + 56320 | 0);
  };
  var CodePoints_instance;
  function CodePoints_getInstance() {
    return CodePoints_instance;
  }
  function appendCodePoint(_this__u8e3s4, codePoint) {
    // Inline function 'kotlin.apply' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'de.cketti.codepoints.appendCodePoint.<anonymous>' call
    if (CodePoints_instance.x3(codePoint)) {
      _this__u8e3s4.q2(numberToChar(codePoint));
    } else {
      _this__u8e3s4.q2(CodePoints_instance.y3(codePoint));
      _this__u8e3s4.q2(CodePoints_instance.z3(codePoint));
    }
    return _this__u8e3s4;
  }
  //region block: init
  CodePoints_instance = new CodePoints();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = appendCodePoint;
  //endregion
  return _;
}));

//# sourceMappingURL=kotlin-codepoints-parent-kotlin-codepoints.js.map
